#include "bevelbox.h"
#include "lowlevelfunc.h"
#include "awindow.h"

const char *BevelBox::type="BevelBox";

BevelBox::~BevelBox()
{
  if(parent!=NULL) {
    parent->removeSubWin(win);
  }
}

BevelBox::BevelBox(AGUIX *aguix):GUIElement(aguix)
{
  this->state=0;
  bgset=false;
}

BevelBox::BevelBox(AGUIX *aguix,int x,int y,int width,int height,
                   int state):GUIElement(aguix)
{
  this->x=x;
  this->y=y;
  this->w=width;
  this->h=height;
  this->state=state;
  bgset=false;
}

int BevelBox::getState()
{
  return state;
}

void BevelBox::setState(int state)
{
  if(state==1) this->state=state;
  else this->state=0;
  redraw();
}

void BevelBox::redraw()
{
  if(bgset==false) {
    aguix->SetWindowBG(win,parent->getBG());
    bgset=true;
  }
  aguix->ClearWin(win);
  if(state==0) {
    aguix->setFG(2);
  } else {
    aguix->setFG(1);
  }
  aguix->DrawLine(win,0,h-1,0,0);
  aguix->DrawLine(win,0,0,w-1,0);
  if(state==0) {
    aguix->setFG(1);
  } else {
    aguix->setFG(2);
  }
  aguix->DrawLine(win,0,h-1,w-1,h-1);
  aguix->DrawLine(win,w-1,h-1,w-1,1);
}

void BevelBox::flush()
{
}

bool BevelBox::handleMessage(XEvent *E,Message *msg)
{
  if((msg->type==Expose)&&(msg->window==win)) {
    redraw();
  }
  return false;
}

const char *BevelBox::getType()
{
  return type;
}

bool BevelBox::isType(const char *qtype)
{
  if(strcmp(type,qtype)==0) return true;
  return false;
}
