#ifndef CHOOSEBUTTON_H
#define CHOOSEBUTTON_H

#include "guielement.h"

class AGUIXFont;

enum {LABEL_TOP,LABEL_LEFT,LABEL_BOTTOM,LABEL_RIGHT};

class ChooseButton:public GUIElement {
public:
  ChooseButton(AGUIX *aguix);
  ChooseButton(AGUIX *aguix,int x,int y,int width,int height,bool state,
               const char *label,int labelpos,int labelcolor,int data);
  virtual ~ChooseButton();
  char *getLabel();
  void setLabel(const char *);
  virtual void resize(int w,int h); // Notwendig, da Gre des ChooseButtons nicht die Gre
                                    // des Fensters ist
  virtual void move(int x,int y);
  void setLabelPos(int);
  int getLabelPos();
  void setLabelColor(int);
  int getLabelColor();
  int getData();
  void setData(int);
  void setState(bool);
  int getState();
  virtual void redraw();
  virtual void flush();
  bool isInside(int x,int y);
  virtual bool handleMessage(XEvent *E,Message *msg);
  virtual void setParent(AWindow *parent);
  int setFont(char *);
  virtual const char *getType();
  virtual bool isType(const char *type);
  virtual bool isParent(Window);
  int getX();
  int getY();
  int getWidth();
  int getHeight();
private:
  char *label;
  int labelpos;
  int labelcolor;
  int data;
  bool state;
  bool instate;
  bool laststate;
  bool bgset;
  bool cross;
  static const char *type;
  int lx,ly,lw,lh;
  void calcLabelGeometry();
  void updateWin();
  void calcRealPos(int,int);
  int getLabelWidth();
  int getLabelHeight();
  Window lwin;
  void lredraw();
  void cbredraw();
  AGUIXFont *font;
};

#endif
