#include "guielement.h"
#include "awindow.h"

const char *GUIElement::type="GUIElement";

GUIElement::GUIElement(AGUIX *aguix)
{
  this->aguix=aguix;
  x=0;
  y=0;
  w=1;
  h=1;
  win=0;
  parent=NULL;
}

GUIElement::~GUIElement()
{
  if(parent!=NULL) {
    parent->removeSubWin(win);
  }
}

void GUIElement::move(int x,int y)
{
  this->x=x;
  this->y=y;
  if(parent!=NULL) {
    parent->moveSubWin(win,x,y);
    redraw();
  }
}

void GUIElement::resize(int w,int h)
{
  if((w<1)||(h<1)) return;
  this->w=w;
  this->h=h;
  if(parent!=NULL) {
    parent->resizeSubWin(win,w,h);
    redraw();
  }
}

void GUIElement::redraw()
{
}

void GUIElement::flush()
{
}

const char *GUIElement::getType()
{
  return type;
}

bool GUIElement::isType(const char *qtype)
{
  if(strcmp(type,qtype)==0) return true;
  return false;
}

bool GUIElement::handleMessage(XEvent *E,Message *msg)
{
  // true falls die Message interessiert
  // false wenn nicht
  return false;
}

void GUIElement::getPos(int *x,int *y)
{
  *x=this->x;
  *y=this->y;
}

void GUIElement::getSize(int *w,int *h)
{
  *w=this->w;
  *h=this->h;
}

void GUIElement::setParent(AWindow *parent)
{
  this->parent=parent;
  win=parent->getSubWindow(0,x,y,w,h);
}

bool GUIElement::hasWin(Window win)
{
  if(this->win==win) return true;
  return false;
}

Window GUIElement::getWindow()
{
  return win;
}

int GUIElement::getWidth()
{
  return w;
}

int GUIElement::getHeight()
{
  return h;
}

void GUIElement::toBack()
{
  aguix->WindowtoBack(win);
}

void GUIElement::toFront()
{
  aguix->WindowtoFront(win);
}

int GUIElement::getX()
{
  return x;
}

int GUIElement::getY()
{
  return y;
}

bool GUIElement::isParent(Window win)
{
  if(this->win==win) return true;
  return false;
}
