#ifndef CURSOROPS_H
#define CURSOROPS_H

#include "functionproto.h"
class Worker;

class RowUp:public FunctionProto
{
public:
  RowUp(Worker*);
  virtual ~RowUp();
  virtual RowUp *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class RowDown:public FunctionProto
{
public:
  RowDown(Worker*);
  virtual ~RowDown();
  virtual RowDown *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class FirstRow:public FunctionProto
{
public:
  FirstRow(Worker*);
  virtual ~FirstRow();
  virtual FirstRow *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class LastRow:public FunctionProto
{
public:
  LastRow(Worker*);
  virtual ~LastRow();
  virtual LastRow *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class PageUp:public FunctionProto
{
public:
  PageUp(Worker*);
  virtual ~PageUp();
  virtual PageUp *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class PageDown:public FunctionProto
{
public:
  PageDown(Worker*);
  virtual ~PageDown();
  virtual PageDown *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class SelectOp:public FunctionProto
{
public:
  SelectOp(Worker*);
  virtual ~SelectOp();
  virtual SelectOp *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class SelectAllOp:public FunctionProto
{
public:
  SelectAllOp(Worker*);
  virtual ~SelectAllOp();
  virtual SelectAllOp *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class SelectNoneOp:public FunctionProto
{
public:
  SelectNoneOp(Worker*);
  virtual ~SelectNoneOp();
  virtual SelectNoneOp *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class InvertAllOp:public FunctionProto
{
public:
  InvertAllOp(Worker*);
  virtual ~InvertAllOp();
  virtual InvertAllOp *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class ParentDirOp:public FunctionProto
{
public:
  ParentDirOp(Worker*);
  virtual ~ParentDirOp();
  virtual ParentDirOp *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class EnterDirOp:public FunctionProto
{
public:
  EnterDirOp(Worker*);
  virtual ~EnterDirOp();
  virtual EnterDirOp *duplicate();
  virtual int configure();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
  virtual int load(Datei*);
  virtual bool save(Datei *);

  typedef enum {ENTERDIROP_ACTIVE=0,
                ENTERDIROP_ACTIVE2OTHER,
                ENTERDIROP_SPECIAL,
                ENTERDIROP_REQUEST} enterdir_t;
  void setMode(enterdir_t);
  void setDir(const char*);
protected:
  static const char *name;
  // Infos to save
  enterdir_t enterdirmode;
  char *dir;
};

#endif

