#ifndef FUNCTIONPROTO_H
#define FUNCTIONPROTO_H

#include <stdio.h>

class Datei;
class Worker;
class AGUIX;
class WCGlobalFlags;
class Lister;

class ActionMessage
{
public:
  ActionMessage();
  ~ActionMessage();
  WCGlobalFlags *flags;
  
  typedef enum {AM_MODE_NORMAL,
                AM_MODE_ONLYACTIVE,
                AM_MODE_DNDACTION,
                AM_MODE_SPECIAL} am_mode_t;
  am_mode_t mode;
  Lister *startLister;
  void *extraInfo;
};

class FunctionProto
{
public:
  FunctionProto(Worker*);
  virtual ~FunctionProto();
  virtual int configure();
  virtual int load(Datei*);
  virtual FunctionProto *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual bool save(Datei *);
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
  
  static FunctionProto *preload(Worker*,Datei*);
  static int presave(Datei*,FunctionProto*);
protected:
  static const char *name;
  Worker *worker;
};

#endif
