#ifndef LOCALE_H
#define LOCALE_H

#include <stdlib.h>
#include <aguix/lowlevelfunc.h>
#include "datei.h"
#include <ctype.h>

#define CATENTRY 368
#define CATCOMENTRY 40
#define CATFLAGENTRY 37

class Locale {
public:
  Locale();
  ~Locale();
//  void init(const char*);
  int loadLanguage(const char*);
  void freeLanguage();
  char *getLocale(int);
  char *getLocaleCom(int);
  char *getLocaleFlag(int);
private:
  char **catalog;
  char **catalogcom;
  char **catalogflag;
  
  void initBuiltinLang();
  void parse(Datei*,int);
  int openCatFile(Datei*file,const char *name,const char *ext);
};

extern Locale catalog;

#endif

