#ifndef NORMALOPS_H
#define NORMALOPS_H

#include "functionproto.h"
class Worker;

class ChangeListerSetOp:public FunctionProto
{
public:
  ChangeListerSetOp(Worker*);
  virtual ~ChangeListerSetOp();
  virtual ChangeListerSetOp *duplicate();
  virtual int configure();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
  virtual int load(Datei*);
  virtual bool save(Datei *);

  enum { CLS_LEFT_LISTER,CLS_RIGHT_LISTER,CLS_ACTUAL_LISTER,CLS_OTHER_LISTER};
  void setMode(int);
protected:
  static const char *name;
  int mode;
};

class SwitchListerOp:public FunctionProto
{
public:
  SwitchListerOp(Worker*);
  virtual ~SwitchListerOp();
  virtual SwitchListerOp *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class FilterSelectOp:public FunctionProto
{
public:
  FilterSelectOp(Worker*);
  virtual ~FilterSelectOp();
  virtual FilterSelectOp *duplicate();
  virtual int configure();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
  virtual int load(Datei*);
  virtual bool save(Datei *);
  
  bool requestfilter();
protected:
  static const char *name;
  char *filter;
  char *actual_filter;
};

class FilterUnSelectOp:public FilterSelectOp
{
public:
  FilterUnSelectOp(Worker*);
  virtual ~FilterUnSelectOp();
  virtual FilterUnSelectOp *duplicate();
  virtual int configure();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
  
  bool requestfilter();
protected:
  static const char *name;
};

class Path2OSideOp:public FunctionProto
{
public:
  Path2OSideOp(Worker*);
  virtual ~Path2OSideOp();
  virtual Path2OSideOp *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
protected:
  static const char *name;
};

class QuitOp:public FunctionProto
{
public:
  QuitOp(Worker*);
  virtual ~QuitOp();
  virtual QuitOp *duplicate();
  virtual int configure();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual const char *getDescription();
  virtual int load(Datei*);
  virtual bool save(Datei *);
  
  void setMode(int);
  enum {Q_NORMAL_QUIT,Q_QUICK_QUIT};
protected:
  static const char *name;
  int mode;
};

#endif

