#ifndef WDEFINES_H
#define WDEFINES_H

#include <time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/param.h>  /* for MAXPATHLEN ... */
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <sys/time.h>
#include <errno.h>
#include <grp.h>
#include <pwd.h>

#ifdef HAVE_CONFIG_H
  #ifndef CONFIG_H_INCLUDED
    #include "../config.h"
    #define CONFIG_H_INCLUDED
  #endif
#endif

#if defined(HAVE_SYS_STATVFS_H)
  #include <sys/statvfs.h>
#elif ( defined(BSD) && (BSD >= 199506) )
  /* statfs on FreeBSD-2.2.2, BSD is defined in sys/param.h */
  #include <sys/mount.h>
#endif
#ifdef HAVE_SYS_VFS_H
  #include <sys/vfs.h>
#endif
#ifdef HAVE_SYS_SYSINFO_H
  #include <sys/sysinfo.h>
#endif

#include <aguix/aguixdefs.h>

#ifdef HAVE_LIBZ
  #include <zlib.h>
#endif

#define CP_COMMAND "cp -a %s %s"
#define CP_COMMAND_FORCE "cp -a -f %s %s"
#define OUTPUT_BIN "xmessage -file %s"
#define TERMINAL_BIN "xterm -e %s"

#ifndef LINUX
  #ifndef ARG_MAX
    #ifdef _POSIX_ARG_MAX
      #define ARG_MAX _POSIX_ARG_MAX
    #else
      #define ARG_MAX MAXPATHLEN
    #endif
  #endif
#endif

#define EXE_STRING_LEN ARG_MAX

#ifdef DEVELOPER
  #define USEOWNCONFIGFILES
#endif

#ifndef PREFIX
  #define GLOBALDATADIR "/usr/local/share/worker"
#else
  #define GLOBALDATADIR PREFIX"/share/worker"
#endif

#define max(a,b) (((a)>(b))?(a):(b))

#endif
