#ifndef WORKER_H
#define WORKER_H

#include <aguix/lowlevelfunc.h>
#include <aguix/aguix.h>
#include <aguix/util.h>
#include <aguix/message.h>
#include <aguix/button.h>
#include <aguix/solidbutton.h>
#include <aguix/request.h>
#include "functionproto.h"
#include "wconfig.h"

class ListerMode;
class Lister;

class Worker
{
public:
  Worker(int argc,char **argv);
  ~Worker();
  void run();
  AGUIX *getAGUIX();
  int getMaxModeNr();
  static int getID4Mode(ListerMode*);
  ListerMode *getMode4ID(int,Lister *);
  AWindow *getMainWin();
  void getGeometry(Lister*,int*,int*,int*,int*);
  void setStatebarText(const char*);
  static int getNrOfCommands();
  FunctionProto *getCommand4ID(int);
  static int getID4Command(FunctionProto*);
  Lister *getOtherLister(Lister*);
  int getSide(Lister*);
  Lister *getLister(int);
  Lister *getActiveLister();
  int interpret(List*,ActionMessage *);
  
  int quit(int mode);
protected:
  void buildMainWin(bool);
  void resizeMainWin(int,int);
  void shufflePath();
  void shuffleButton();
  void about();
  bool configure();
  void showPathBank();
  void showButtonBank();
  void setPath(int);
  void activateShortkey(AGMessage*);
  void activateButton(int,int,int);
  int saveListerState();
  int initListerState();
  void updateTime();

  AGUIX *aguix;
  Lister *lister[2];
  AWindow *mainwin;
  Button *aboutb,*configureb,*clockbar;
  SolidButton *statebar;
  Button **pathbs;
  Button **buttons;
  int w,h;
  unsigned int oldrows,oldcoloums;
  int pbanknr,bbanknr;
  
  enum {WORKER_NORMAL,WORKER_QUIT};
  int runningmode;
  int argc;
  char **argv;
  time_t lasttimep;
};

#define WORKER_MAJOR 2
#define WORKER_MINOR 0
#define WORKER_PATCH 1

#endif

